package net.sergeych.bintools

/**
 * data input stream-like abstraction. We need it because
 * kotlinx serialization is synchronous and there us nothing
 * like multiplatform version of DataInput
 *
 */
interface DataSource {

    fun readByte(): Byte

    val position: Int

    fun readUByte() = readByte().toUByte()

    @Suppress("unused")
    fun readBytes(size: Int): ByteArray =
        ByteArray(size).also { a ->
            for( i in 0..size)
                a[i] = readByte()
        }
}

fun ByteArray.toDataSource(): DataSource =
    object : DataSource {
        override var position = 0

        override fun readByte(): Byte = this@toDataSource[position++]
    }